<?php

namespace backend\controllers;

use Yii;
use common\models\MessageDetsta;
use backend\models\MessageDetstaSearch;
use yii\web\Controller;
use yii\web\NotFoundHttpException;
use yii\filters\VerbFilter;
use common\components\giro\GiroDETSTA;
use common\components\DetStaDBSave;

/**
 * MessageDetstaController implements the CRUD actions for MessageDetsta model.
 * 
 * TODO : FIX ACCESS
 */
class MessageDetstaController extends Controller
{
	public function behaviors()
	{
		return [
				'access' => [
						'class' => \yii\filters\AccessControl::className(),
						'rules' => [
								// allow authenticated users
								[
										'actions' => [ ],
										'allow' => true,
										'roles' => ['admin','employee','reception'],
								],
								// everything else is denied
						],
				],
		];
	}

    /**
     * Lists all MessageDetsta models.
     * @return mixed
     */
    public function actionIndex()
    {
    	$filename = \Yii::getAlias("@backend") ."/web/giro/valasz/detsta.txt";
    	$ugiro = GiroDETSTA::parse(file_get_contents($filename));
    	
    	file_put_contents("c:\\tmp\\detsta.txt", $ugiro->toString());
    	
    	$saver =  new DetStaDBSave(
    			[
    					'giroDETSTA' => $ugiro,
    					'koteg' => null,
    					'idUser' =>\Yii::$app->user->id
    			]);
    	
    	$saver->run();
    	
        $searchModel = new MessageDetstaSearch();
        $dataProvider = $searchModel->search(Yii::$app->request->queryParams);

        return $this->render('index', [
            'searchModel' => $searchModel,
            'dataProvider' => $dataProvider,
        ]);
    }

    /**
     * Displays a single MessageDetsta model.
     * @param integer $id
     * @return mixed
     */
    public function actionView($id)
    {
        return $this->render('view', [
            'model' => $this->findModel($id),
        ]);
    }

    /**
     * Creates a new MessageDetsta model.
     * If creation is successful, the browser will be redirected to the 'view' page.
     * @return mixed
     */
    public function actionCreate()
    {
        $model = new MessageDetsta();

        if ($model->load(Yii::$app->request->post()) && $model->save()) {
            return $this->redirect(['view', 'id' => $model->id_message]);
        } else {
            return $this->render('create', [
                'model' => $model,
            ]);
        }
    }

    /**
     * Updates an existing MessageDetsta model.
     * If update is successful, the browser will be redirected to the 'view' page.
     * @param integer $id
     * @return mixed
     */
    public function actionUpdate($id)
    {
        $model = $this->findModel($id);

        if ($model->load(Yii::$app->request->post()) && $model->save()) {
            return $this->redirect(['view', 'id' => $model->id_message]);
        } else {
            return $this->render('update', [
                'model' => $model,
            ]);
        }
    }

    /**
     * Deletes an existing MessageDetsta model.
     * If deletion is successful, the browser will be redirected to the 'index' page.
     * @param integer $id
     * @return mixed
     */
    public function actionDelete($id)
    {
        $this->findModel($id)->delete();

        return $this->redirect(['index']);
    }

    /**
     * Finds the MessageDetsta model based on its primary key value.
     * If the model is not found, a 404 HTTP exception will be thrown.
     * @param integer $id
     * @return MessageDetsta the loaded model
     * @throws NotFoundHttpException if the model cannot be found
     */
    protected function findModel($id)
    {
        if (($model = MessageDetsta::findOne($id)) !== null) {
            return $model;
        } else {
            throw new NotFoundHttpException('The requested page does not exist.');
        }
    }
}
